package Plugins::filejungle;

use strict;
use warnings;
use lib '..';
use lib '../Modules/';
use Plugin;                                                                                                                                                                      
use base 'Plugin'; 
use HTTP::Request;
use HTTP::Request::Common qw(POST GET PUT);
use Data::Dumper;
use vars qw($VERSION);

our $options = {
		plugin_id => 1019,
		plugin_prefix=>'fj',
		domain=>'filejungle.com',
		name=>'filejungle',
		can_login=>1,
		upload=>1,
		download=>1,
};

sub check_link {
	shift;                                                                                                                                                                       
	my $link = shift;                                                                                                                                                            
	if ($link =~ /filejungle\.com/) {                                                                                                                                          
		return 1;                                                                                                                                                                
	}                                                                                                                                                                            
	return 0; 
}

sub is_broken {
	my $self = shift;
	my $link = shift;
	$self->get($link);
	return 1 if($self->{content} =~ /File not available/);
	return 0;
}

sub max_filesize {
	return 1048*1024*1024;
}


sub login {
	my $self = shift;
	my $a = shift;
	$self->{action} = 'login';
	$self->get('http://filejungle.com/');
	my $req = POST "http://filejungle.com/login.php",
	        Referer => 'http://filejungle.com/',
       	Content => [loginUserName=>$a->{login}, loginUserPassword=>$a->{password}, loginFormSubmit=>'Login'];
	my $r = $self->request($req);
	
	if(($r->is_success) || ($r->code == 302)) {
		$self->get('http://filejungle.com/dashboard.php');
		my $content = $r->as_string();
		return 0 if($content =~ /  email  /);
		return 0 if($content =~ /Введен неправильный email или пароль/);
		return 0 if($content =~ /captcha/);
		$self->{last_account} = $a;
		return 1;

	} else {
		return 0;
	}
	return 1;
}
sub upload_file {
	my $self = shift;
	my $file = shift;
	my $filename = shift;
	my $description = shift;
	$self->{action} = 'upload';
	$self->get('http://filejungle.com');
	my ($action) = $self->{content} =~ /var uploadUrl = \'([^\']+)/;
#	$action='http://filejungle.com/'.$action;
#	$self->get($action.'?callback=jsonp1318320389467&_=1318320436586');
#	my ($sess_id) = $self->{content} =~ /sessionId:'([^']+)\'/;	
	open FD, "< $c->{filesdir}/$file";
	my $rd = sub {read(FD, my $buf, 655535);return $buf;};
	my $req = HTTP::Request->new("PUT",$action, [
		'X-File-Name'=>$filename,
		'X-File-Size'=>-s "$c->{filesdir}/$file",
		'Content-Length'=>-s "$c->{filesdir}/$file",
		Referer	=> 'http://filejungle.com/index.php',
		Origin	=> 'http://filejungle.com',
		Content_Type => "multipart/form-data",
		], $rd
		);
	$self->up_file($req);
	my $download = '';
	if($self->{content} =~ /\"shortenCode\":\"([^\"]+)/) {
		my $sc = $1;
		$download = 'http://filejungle.com/f/'.$sc.'/'.$filename;
	};
#	close FD;
	return {download=>$download, remove=>''};
	
}

sub download {
	my $self = shift;
	my $url = shift;
	my $prefix = shift;
	my $update_stat = shift;
	my $req = GET $url;
	my $response;
	my $dlink = '';
	$self->{action} = 'download';
	
	my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
	$log->write(2, 'type:'.$ff->{type});
	if($ff->{type} =~ /html/) {#direct download don't enable or user not premium
		my $r = $self->get($url);
		return {error=>1, }
	}
	return {error=>0, filename=>$ff->{filename}, filesize=>$ff->{filesize}};

}
1;
