package Plugins::shareonline;

use strict;
use warnings;
use lib '..';
use Plugin;                          
                                                                                                                                           
use base 'Plugin'; 
use HTTP::Request::Common qw(POST GET);
use MIME::Base64;
use XML::Simple;
use Data::Dumper;
use vars qw($VERSION);

$VERSION = "1.6" ;

our $options = {
		plugin_id => 1030,
		plugin_prefix=>'so',
		domain=>'share-online.biz',
		name=>'shareonline',
		required_login=>1,
		can_login => 1,
		upload=>1,
		download=>1,
};

sub check_link {
	shift;
	my $link = shift;
	if ($link =~ /share\-online\.biz/) {
		return 1;
	}
	return 0;
}

sub is_broken {
	my $self = shift;
	my $link = shift;
	$self->get($link);
	return 1 if($self->{content} =~ /this file has been removed/);
	return 0;
}

sub max_filesize {
	return 1024*1024*1024;
}
sub login {
	my $self = shift;
	my $a = shift;
	$self->{action} = 'login';
	my $req = GET 'http://www.share-online.bix/user/login';
	$self->request($req);
#	$base = $self->{response}->base();
	
	$req = POST "https://www.share-online.biz/user/login",
#	        Referer => "https://www.share-online.biz/",
	       	Content => [user=>$a->{login}, pass=>$a->{password}];	
	$self->request($req);
	$self->{account} = $a;
#	if(($self->{response}->is_success) || ($self->{response}->code == 302)) {
#		return 0 if($self->{content} =~ /No user found with such email/);
#		return 0 if($self->{content} =~ /Login failed/);
#		return 1;
#	} else {
#		return 0;
#	}
}


sub upload_file {
	my $self = shift;
	my $file = shift;
	my $filename = shift;
	my $description = shift;
	$self->{action} = 'upload';
	$self->get('http://www.share-online.biz/upv3_session.php?username='.$self->{account}->{login}.'&password='.$self->{account}->{password});
	my @s = split(';',$self->{content});
	if($s[1] && $s[0]) {
		$s[1] = 'http://'.$s[1] unless($s[1] =~ m~http://~);
		my $req = POST $s[1],
			Content_Type => "multipart/form-data",
	        	Content => [username=>$self->{account}->{login}, password=>$self->{account}->{password}, 
					upload_session=>$s[0],chunk_no=>1,chunk_number=>1,fielsize=>-s "$c->{filesdir}/$file",
						fn=>["$c->{filesdir}/$file", $filename],finalize=>1];
		$self->up_file($req);
		@s = split(';',$self->{content});
		my $remove = '';
		my $link = $s[0];
		return {download=>$link, remove=>$remove};
		
	}
	
}
sub download {
	my $self = shift;
	my $url = shift;
	my $prefix = shift;
	my $update_stat = shift;
	my $req;
	my $response;
	my $dlink = '';
	$self->{action} = 'download';
	$req = GET $url;
	my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
	if($ff->{type} =~ /html/) {
		$self->request($req);
		$self->{content} =~ /dl="([^"]+)/;
		my $dl = $1;
		my $dlink = decode_base64($dl);
		$req = GET $dlink;
		my $ff = $self->direct_download($req, $url, $prefix, $update_stat);
		if($ff->{type} =~ /html/) {
			return {error=>-2, error_text=>'Cannot download direct link'};
		} 
	}
	return {error=>0, filename=>$ff->{filename}, filesize=>$ff->{filesize}};
	

}

1;
