#!/usr/bin/perl
### SibSoft.net ###
use strict;
use lib '.';
use XFSConfig;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use LWP::UserAgent;

my $MAX_FILES_IN_TORRENT = 256; # avoid huge torrents with many small files

print("Content-type:text/html\n\nXFS"),exit if $ENV{QUERY_STRING}=~/mode=test/;

$c->{max_upload_filesize} = $c->{max_upload_filesize_prem};

backToMyTorrents("Torrent mod disabled on this site") unless $c->{m_t};

my $cg = CGI->new();

#########################

my $f;
$f->{$_}=$cg->param($_) for $cg->param();
$f->{ip} = &GetIP();

TorrentUpload();

sub parseTorrent
{
    require BitTorrent;
    my $bt = BitTorrent->new();
    my $tt = $bt->getTrackerInfo($_[0]);

    my ($over,@files);
    foreach my $ff ( @{$tt->{files}} )
    {
        next if $ff->{name}=~/padding_file/;
        $over=1 if $ff->{size} > $c->{max_upload_filesize}*1048576;
        #$files.="$ff->{name}:$ff->{size}\n";
        push @files, qq[{"path":"$ff->{name}","size":$ff->{size}}];
    }

    backToMyTorrents("One or more files in torrent exceed filesize limit of $c->{max_upload_filesize} Mb") if $c->{max_upload_filesize} && $over;
    backToMyTorrents("Too many files > $MAX_FILES_IN_TORRENT") if @files > $MAX_FILES_IN_TORRENT;
    return ($tt->{hash},'['.join(",",@files).']');
}

sub TorrentUpload
{
    require TorrentClient;

    my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 90);
    my $tt = TorrentClient->new();

    my ($hash,$files);
    ($hash,$files) = parseTorrent($cg->tmpFileName($f->{file_0})) if $f->{file_0};
    $hash = lc($1) if $f->{magnet} =~ /btih:([0-9a-zA-Z]+)/;

    my $res;
    if($f->{file_0})
    {
	    my $file_tmp = $cg->tmpFileName($f->{file_0});
	    $res = $tt->startdl(metainfo => [ $file_tmp ], fs_key => $c->{host_id});
    }
 	elsif($f->{magnet})
    {
        $res = $tt->startdl(magnet => $f->{magnet}, fs_key => $c->{host_id});
    }
    else
    {
    	backToMyTorrents("No torrents found");
    }

   if($res =~ /^OK/)
   {
      my @extras;
      push @extras, "$_=$f->{$_}" for grep{/^extra_/ && $f->{$_}} keys %$f;
      push @extras, "$_=$f->{$_}" for grep{$f->{$_}} ('cat_id','file_public','file_adult','tags');

      my $res = $ua->post("$c->{site_cgi}/fs.cgi",
                          {
                          op           => 'add_torrent',
                          dl_key       => $c->{dl_key},
                          sid          => $hash,
                          sess_id      => $f->{sess_id}||'',
                          srv_id       => $c->{torrent_srv_id},
                          files        => $files,
                          total_size   => $tt->{total_size},
                          extras       => join("\n",@extras),
                          }
                         )->content;
      if($res ne 'OK')
      {
         #die $res if $res=~/\n+/s;
         backToMyTorrents($res);
      }

      backToMyTorrents("");
   }
   else
   {
      backToMyTorrents("Torrent engine is not running") if $res=~/500 Can't connect/i;
      die"bitttorent error: $res";
   }
}

####################################################################################################################################

sub logit
{
   my $msg = shift;
   return unless $c->{uploads_log};
   my @t = &getTime;
   open(FILE,">>$c->{uploads_log}") || return;
   print FILE &GetIP." $t[0]-$t[1]-$t[2] $t[3]:$t[4]:$t[5] $msg\n";
   close FILE;
}

sub getTime
{
    my @t = localtime();
    return ( sprintf("%04d",$t[5]+1900),
             sprintf("%02d",$t[4]+1), 
             sprintf("%02d",$t[3]), 
             sprintf("%02d",$t[2]), 
             sprintf("%02d",$t[1]), 
             sprintf("%02d",$t[0]) 
           );
}

sub GetIP
{
 return $ENV{HTTP_X_FORWARDED_FOR} || $ENV{HTTP_X_REAL_IP} || $ENV{REMOTE_ADDR};
}

sub backToMyTorrents
{
   my ($msg) = @_;
   print"Content-type:text/html\n\n";
   print qq[<html><body onload="document.F1.submit()"><form name="F1" action="$c->{site_url}/" method="GET" style="display:none">
            <input type="hidden" name="op" value="my_torrents">
            <input type="hidden" name="msg" value="$msg">
            </form></body></html>];
   exit;
}

